]> git.ipfire.org Git - thirdparty/git.git/blame - t/test-lib.sh
Merge branch 'maint-2.0' into maint-2.1
[thirdparty/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
85176d72
FC
29else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
33fi
34if test -z "$TEST_OUTPUT_DIRECTORY"
35then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39fi
40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
2006f0ad
RR
42################################################################
43# It appears that people try to run tests without building...
44"$GIT_BUILD_DIR/git" >/dev/null
45if test $? != 1
46then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
49fi
50
3c8f12c9
JH
51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52export PERL_PATH SHELL_PATH
53
4cde519f
RR
54# if --tee was passed, write the output not only to the terminal, but
55# additionally to the file test-results/$BASENAME.out, too.
56case "$GIT_TEST_TEE_STARTED, $* " in
57done,*)
58 # do not redirect again
59 ;;
60*' --tee '*|*' --va'*)
2d14e13c
JK
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
4cde519f
RR
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
67 ;;
68esac
69
e1970ce4
JH
70# For repeatability, reset the environment to known value.
71LANG=C
899460f3 72LC_ALL=C
d9bdd39e 73PAGER=cat
e1970ce4 74TZ=UTC
c2116a17
JH
75TERM=dumb
76export LANG LC_ALL PAGER TERM TZ
8ff99e74 77EDITOR=:
661bfd13
SL
78# A call to "unset" with no arguments causes at least Solaris 10
79# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80# deriving from the command substitution clustered with the other
81# ones.
3c8f12c9 82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 83 my @env = keys %ENV;
730477f1
JL
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
ac001282 92 UNZIP
edb54081 93 PERF_
e2a0ccc0 94 CURL_VERBOSE
730477f1
JL
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
97 print join("\n", @vars);
98')
5adf84eb 99unset XDG_CONFIG_HOME
8bade1e1 100unset GITPERLLIB
29e55cd5
JH
101GIT_AUTHOR_EMAIL=author@example.com
102GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
103GIT_COMMITTER_EMAIL=committer@example.com
104GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 105GIT_MERGE_VERBOSITY=5
f8246281
JH
106GIT_MERGE_AUTOEDIT=no
107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 110export EDITOR
e1970ce4 111
124647c4
KB
112# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113GIT_TRACE_BARE=1
114export GIT_TRACE_BARE
115
5d9fc888
TG
116if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
120fi
121
a731fa91
EP
122# Add libc MALLOC and MALLOC_PERTURB test
123# only if we are not executing the test with valgrind
1b3185fc 124if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 125 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
126then
127 setup_malloc_check () {
128 : nothing
129 }
130 teardown_malloc_check () {
131 : nothing
132 }
133else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
137 }
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
140 }
141fi
a731fa91 142
886a3907
JH
143# Protect ourselves from common misconfiguration to export
144# CDPATH into the environment
145unset CDPATH
146
5565f47c 147unset GREP_OPTIONS
ac001282 148unset UNZIP
5565f47c 149
3d5c0cc9 150case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1511|2|true)
152 echo "* warning: Some tests will not work if GIT_TRACE" \
153 "is set as to trace on STDERR ! *"
154 echo "* warning: Please set GIT_TRACE to something" \
155 "other than 1, 2 or true ! *"
156 ;;
6ce4e61f
CC
157esac
158
cd3c095c
JH
159# Convenience
160#
161# A regexp to match 5 and 40 hexdigits
162_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
163_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
164
3749fde5
JH
165# Zero SHA-1
166_z40=0000000000000000000000000000000000000000
167
3f4ab627
JH
168# Line feed
169LF='
170'
171
a42643aa
JK
172# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
173# when case-folding filenames
174u200c=$(printf '\342\200\214')
175
176export _x05 _x40 _z40 LF u200c
342e9ef2 177
e1970ce4
JH
178# Each test should start with something like this, after copyright notices:
179#
180# test_description='Description of this test...
181# This test checks if command xyzzy does the right thing...
182# '
183# . ./test-lib.sh
c2116a17
JH
184[ "x$ORIGINAL_TERM" != "xdumb" ] && (
185 TERM=$ORIGINAL_TERM &&
186 export TERM &&
187 [ -t 1 ] &&
188 tput bold >/dev/null 2>&1 &&
189 tput setaf 1 >/dev/null 2>&1 &&
190 tput sgr0 >/dev/null 2>&1
191 ) &&
55db1df0 192 color=t
e1970ce4 193
e1970ce4
JH
194while test "$#" -ne 0
195do
196 case "$1" in
197 -d|--d|--de|--deb|--debu|--debug)
198 debug=t; shift ;;
886856ab
JH
199 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
200 immediate=t; shift ;;
5e2c08c6 201 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 202 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
203 -r)
204 shift; test "$#" -ne 0 || {
205 echo 'error: -r requires an argument' >&2;
206 exit 1;
207 }
208 run_list=$1; shift ;;
209 --run=*)
210 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
e1970ce4 211 -h|--h|--he|--hel|--help)
570f3226 212 help=t; shift ;;
e1970ce4
JH
213 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
214 verbose=t; shift ;;
ff09af3f
TR
215 --verbose-only=*)
216 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
217 shift ;;
1ece1274 218 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
219 # Ignore --quiet under a TAP::Harness. Saying how many tests
220 # passed without the ok/not ok details is always an error.
221 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
222 --with-dashes)
223 with_dashes=t; shift ;;
55db1df0 224 --no-color)
faa4bc35 225 color=; shift ;;
4e1be63c 226 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
227 valgrind=memcheck
228 shift ;;
229 --valgrind=*)
230 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
231 shift ;;
5dfc368f
TR
232 --valgrind-only=*)
233 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
234 shift ;;
44138559
JS
235 --tee)
236 shift ;; # was handled already
f423ef5f
JK
237 --root=*)
238 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
239 shift ;;
e1970ce4 240 *)
1f729dca 241 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
242 esac
243done
244
26a07309 245if test -n "$valgrind_only"
5dfc368f
TR
246then
247 test -z "$valgrind" && valgrind=memcheck
248 test -z "$verbose" && verbose_only="$valgrind_only"
249elif test -n "$valgrind"
250then
251 verbose=t
252fi
952af351 253
1c0cc756
RJ
254if test -n "$color"
255then
55db1df0 256 say_color () {
c2116a17
JH
257 (
258 TERM=$ORIGINAL_TERM
259 export TERM
55db1df0 260 case "$1" in
1c0cc756
RJ
261 error)
262 tput bold; tput setaf 1;; # bold red
263 skip)
b8fc855a 264 tput setaf 4;; # blue
e8e51955
AS
265 warn)
266 tput setaf 3;; # brown/yellow
1c0cc756 267 pass)
0a6d4751 268 tput setaf 2;; # green
1c0cc756 269 info)
0a6d4751 270 tput setaf 6;; # cyan
1c0cc756
RJ
271 *)
272 test -n "$quiet" && return;;
55db1df0
PH
273 esac
274 shift
5099b99d 275 printf "%s" "$*"
55db1df0 276 tput sgr0
b8eecafd 277 echo
c2116a17 278 )
55db1df0
PH
279 }
280else
281 say_color() {
1ece1274 282 test -z "$1" && test -n "$quiet" && return
55db1df0 283 shift
7bc0911d 284 printf "%s\n" "$*"
55db1df0
PH
285 }
286fi
287
288error () {
289 say_color error "error: $*"
6e7b5aaf 290 GIT_EXIT_OK=t
55db1df0
PH
291 exit 1
292}
293
294say () {
295 say_color info "$*"
296}
297
570f3226
MB
298test "${test_description}" != "" ||
299error "Test script did not set test_description."
300
301if test "$help" = "t"
302then
cb1aefda 303 printf '%s\n' "$test_description"
570f3226
MB
304 exit 0
305fi
306
4d9d62fa 307exec 5>&1
781f76b1 308exec 6<&0
e1970ce4
JH
309if test "$verbose" = "t"
310then
311 exec 4>&2 3>&1
312else
313 exec 4>/dev/null 3>/dev/null
314fi
315
316test_failure=0
317test_count=0
41ac414e
JH
318test_fixed=0
319test_broken=0
2d84e9fb 320test_success=0
e1970ce4 321
d998bd4a
ÆAB
322test_external_has_tap=0
323
faa4bc35 324die () {
6e7b5aaf
CB
325 code=$?
326 if test -n "$GIT_EXIT_OK"
327 then
328 exit $code
329 else
330 echo >&5 "FATAL: Unexpected exit with code $code"
331 exit 1
332 fi
faa4bc35
CB
333}
334
6e7b5aaf 335GIT_EXIT_OK=
35641310 336trap 'die' EXIT
41184273 337
12a29b1a
TR
338# The user-facing functions are loaded from a separate file so that
339# test_perf subshells can have them too
3c8f12c9 340. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 341
886856ab 342# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 343# the test_expect_* functions instead.
886856ab
JH
344
345test_ok_ () {
d5d9de1b 346 test_success=$(($test_success + 1))
633fe50a 347 say_color "" "ok $test_count - $@"
e1970ce4
JH
348}
349
886856ab 350test_failure_ () {
d5d9de1b 351 test_failure=$(($test_failure + 1))
633fe50a 352 say_color error "not ok $test_count - $1"
bf0dd8a8 353 shift
cb1aefda 354 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 355 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
356}
357
41ac414e 358test_known_broken_ok_ () {
41ac414e 359 test_fixed=$(($test_fixed+1))
633fe50a 360 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
361}
362
363test_known_broken_failure_ () {
41ac414e 364 test_broken=$(($test_broken+1))
633fe50a 365 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 366}
886856ab
JH
367
368test_debug () {
8e832ebc 369 test "$debug" = "" || eval "$1"
e1970ce4
JH
370}
371
e6a6ddc9
TR
372match_pattern_list () {
373 arg="$1"
374 shift
375 test -z "$*" && return 1
376 for pattern_
377 do
378 case "$arg" in
379 $pattern_)
380 return 0
381 esac
382 done
383 return 1
384}
385
0445e6f0
IB
386match_test_selector_list () {
387 title="$1"
388 shift
389 arg="$1"
390 shift
391 test -z "$1" && return 0
392
393 # Both commas and whitespace are accepted as separators.
394 OLDIFS=$IFS
395 IFS=' ,'
396 set -- $1
397 IFS=$OLDIFS
398
399 # If the first selector is negative we include by default.
400 include=
401 case "$1" in
402 !*) include=t ;;
403 esac
404
405 for selector
406 do
407 orig_selector=$selector
408
409 positive=t
410 case "$selector" in
411 !*)
412 positive=
413 selector=${selector##?}
414 ;;
415 esac
416
417 test -z "$selector" && continue
418
419 case "$selector" in
420 *-*)
421 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
422 then
423 echo "error: $title: invalid non-numeric in range" \
424 "start: '$orig_selector'" >&2
425 exit 1
426 fi
427 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
428 then
429 echo "error: $title: invalid non-numeric in range" \
430 "end: '$orig_selector'" >&2
431 exit 1
432 fi
433 ;;
434 *)
435 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
436 then
437 echo "error: $title: invalid non-numeric in test" \
438 "selector: '$orig_selector'" >&2
439 exit 1
440 fi
441 esac
442
443 # Short cut for "obvious" cases
444 test -z "$include" && test -z "$positive" && continue
445 test -n "$include" && test -n "$positive" && continue
446
447 case "$selector" in
448 -*)
449 if test $arg -le ${selector#-}
450 then
451 include=$positive
452 fi
453 ;;
454 *-)
455 if test $arg -ge ${selector%-}
456 then
457 include=$positive
458 fi
459 ;;
460 *-*)
461 if test ${selector%%-*} -le $arg \
462 && test $arg -le ${selector#*-}
463 then
464 include=$positive
465 fi
466 ;;
467 *)
468 if test $arg -eq $selector
469 then
470 include=$positive
471 fi
472 ;;
473 esac
474 done
475
476 test -n "$include"
477}
478
ff09af3f
TR
479maybe_teardown_verbose () {
480 test -z "$verbose_only" && return
481 exec 4>/dev/null 3>/dev/null
482 verbose=
483}
484
485last_verbose=t
486maybe_setup_verbose () {
487 test -z "$verbose_only" && return
26a07309 488 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
489 then
490 exec 4>&2 3>&1
491 # Emit a delimiting blank line when going from
492 # non-verbose to verbose. Within verbose mode the
493 # delimiter is printed by test_expect_*. The choice
494 # of the initial $last_verbose is such that before
495 # test 1, we do not print it.
496 test -z "$last_verbose" && echo >&3 ""
497 verbose=t
498 else
499 exec 4>/dev/null 3>/dev/null
500 verbose=
501 fi
502 last_verbose=$verbose
503}
504
5dfc368f
TR
505maybe_teardown_valgrind () {
506 test -z "$GIT_VALGRIND" && return
507 GIT_VALGRIND_ENABLED=
508}
509
510maybe_setup_valgrind () {
511 test -z "$GIT_VALGRIND" && return
26a07309 512 if test -z "$valgrind_only"
5dfc368f
TR
513 then
514 GIT_VALGRIND_ENABLED=t
515 return
516 fi
517 GIT_VALGRIND_ENABLED=
518 if match_pattern_list $test_count $valgrind_only
519 then
520 GIT_VALGRIND_ENABLED=t
521 fi
522}
523
a7c58f28
JN
524test_eval_ () {
525 # This is a separate function because some tests use
526 # "return" to end a test_expect_success block early.
781f76b1 527 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
528}
529
4d9d62fa 530test_run_ () {
b6b0afdc 531 test_cleanup=:
b586744a 532 expecting_failure=$2
a57397b0 533 setup_malloc_check
a7c58f28 534 test_eval_ "$1"
b6b0afdc 535 eval_ret=$?
a57397b0 536 teardown_malloc_check
b586744a
JH
537
538 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
539 then
1b3185fc 540 setup_malloc_check
a7c58f28 541 test_eval_ "$test_cleanup"
1b3185fc 542 teardown_malloc_check
b586744a 543 fi
1c0cc756
RJ
544 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
545 then
57e1538a
ÆAB
546 echo ""
547 fi
aa0bcf96 548 return "$eval_ret"
4d9d62fa
PR
549}
550
ae75342c 551test_start_ () {
8586f98b 552 test_count=$(($test_count+1))
ff09af3f 553 maybe_setup_verbose
5dfc368f 554 maybe_setup_valgrind
ae75342c
TR
555}
556
557test_finish_ () {
558 echo >&3 ""
5dfc368f 559 maybe_teardown_valgrind
ff09af3f 560 maybe_teardown_verbose
ae75342c
TR
561}
562
563test_skip () {
04ece593 564 to_skip=
ef2ac68d 565 skipped_reason=
e6a6ddc9
TR
566 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
567 then
568 to_skip=t
ef2ac68d 569 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 570 fi
05236a5e
JN
571 if test -z "$to_skip" && test -n "$test_prereq" &&
572 ! test_have_prereq "$test_prereq"
a7bb3940
JS
573 then
574 to_skip=t
ef2ac68d 575
07431fc8 576 of_prereq=
05236a5e 577 if test "$missing_prereq" != "$test_prereq"
07431fc8 578 then
05236a5e 579 of_prereq=" of $test_prereq"
07431fc8 580 fi
ef2ac68d
IB
581 skipped_reason="missing $missing_prereq${of_prereq}"
582 fi
0445e6f0
IB
583 if test -z "$to_skip" && test -n "$run_list" &&
584 ! match_test_selector_list '--run' $test_count "$run_list"
585 then
586 to_skip=t
587 skipped_reason="--run"
588 fi
07431fc8 589
ef2ac68d
IB
590 case "$to_skip" in
591 t)
633fe50a 592 say_color skip >&3 "skipping test: $@"
ef2ac68d 593 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
594 : true
595 ;;
596 *)
597 false
598 ;;
599 esac
600}
601
342e9ef2
TR
602# stub; perf-lib overrides it
603test_at_end_hook_ () {
604 :
605}
606
e1970ce4 607test_done () {
6e7b5aaf 608 GIT_EXIT_OK=t
2d84e9fb 609
1c0cc756
RJ
610 if test -z "$HARNESS_ACTIVE"
611 then
342e9ef2 612 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 613 mkdir -p "$test_results_dir"
dd78478f
FC
614 base=${0##*/}
615 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 616
c54e6be7
ML
617 cat >>"$test_results_path" <<-EOF
618 total $test_count
619 success $test_success
620 fixed $test_fixed
621 broken $test_broken
622 failed $test_failure
623
624 EOF
8ef1abe5 625 fi
41ac414e
JH
626
627 if test "$test_fixed" != 0
628 then
633fe50a 629 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
630 fi
631 if test "$test_broken" != 0
632 then
633fe50a 633 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
634 fi
635 if test "$test_broken" != 0 || test "$test_fixed" != 0
636 then
637 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
638 msg="remaining $test_remaining test(s)"
11d54b8b 639 else
b73d9a23 640 test_remaining=$test_count
11d54b8b 641 msg="$test_count test(s)"
41ac414e 642 fi
e1970ce4 643 case "$test_failure" in
10b94e28 644 0)
5099b99d 645 # Maybe print SKIP message
bf4b7219
RJ
646 if test -n "$skip_all" && test $test_count -gt 0
647 then
648 error "Can't use skip_all after running some tests"
649 fi
5099b99d
ÆAB
650 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
651
1c0cc756
RJ
652 if test $test_external_has_tap -eq 0
653 then
b73d9a23 654 if test $test_remaining -gt 0
d87bd7c1 655 then
633fe50a 656 say_color pass "# passed all $msg"
d87bd7c1 657 fi
633fe50a 658 say "1..$test_count$skip_all"
d998bd4a 659 fi
abc5d372
JS
660
661 test -d "$remove_trash" &&
662 cd "$(dirname "$remove_trash")" &&
663 rm -rf "$(basename "$remove_trash")"
664
342e9ef2
TR
665 test_at_end_hook_
666
e1970ce4
JH
667 exit 0 ;;
668
669 *)
1c0cc756
RJ
670 if test $test_external_has_tap -eq 0
671 then
633fe50a
TR
672 say_color error "# failed $test_failure among $msg"
673 say "1..$test_count"
d998bd4a 674 fi
5099b99d 675
e1970ce4
JH
676 exit 1 ;;
677
678 esac
679}
680
e4597aae 681if test -n "$valgrind"
4e1be63c 682then
4e1be63c
JS
683 make_symlink () {
684 test -h "$2" &&
685 test "$1" = "$(readlink "$2")" || {
686 # be super paranoid
687 if mkdir "$2".lock
688 then
689 rm -f "$2" &&
690 ln -s "$1" "$2" &&
691 rm -r "$2".lock
692 else
693 while test -d "$2".lock
694 do
695 say "Waiting for lock on $2."
696 sleep 1
697 done
698 fi
699 }
700 }
701
702 make_valgrind_symlink () {
36bfb0e5 703 # handle only executables, unless they are shell libraries that
11d62145 704 # need to be in the exec-path.
36bfb0e5 705 test -x "$1" ||
11d62145 706 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 707 return;
4e1be63c
JS
708
709 base=$(basename "$1")
6cec5c68 710 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
711 # do not override scripts
712 if test -x "$symlink_target" &&
713 test ! -d "$symlink_target" &&
714 test "#!" != "$(head -c 2 < "$symlink_target")"
715 then
716 symlink_target=../valgrind.sh
717 fi
efd92ffd
JS
718 case "$base" in
719 *.sh|*.perl)
720 symlink_target=../unprocessed-script
721 esac
4e1be63c
JS
722 # create the link, or replace it if it is out of date
723 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
724 }
725
26a07309
TR
726 # override all git executables in TEST_DIRECTORY/..
727 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
728 mkdir -p "$GIT_VALGRIND"/bin
729 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
730 do
731 make_valgrind_symlink $file
732 done
733 # special-case the mergetools loadables
734 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
735 OLDIFS=$IFS
736 IFS=:
737 for path in $PATH
738 do
739 ls "$path"/git-* 2> /dev/null |
740 while read file
ad0e6233 741 do
26a07309 742 make_valgrind_symlink "$file"
ad0e6233 743 done
26a07309
TR
744 done
745 IFS=$OLDIFS
4e1be63c
JS
746 PATH=$GIT_VALGRIND/bin:$PATH
747 GIT_EXEC_PATH=$GIT_VALGRIND/bin
748 export GIT_VALGRIND
952af351
TR
749 GIT_VALGRIND_MODE="$valgrind"
750 export GIT_VALGRIND_MODE
5dfc368f 751 GIT_VALGRIND_ENABLED=t
26a07309 752 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 753 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
754elif test -n "$GIT_TEST_INSTALLED"
755then
e4597aae
MO
756 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
757 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 758 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
759 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
760else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 761 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
762 if ! test -x "$git_bin_dir/git"
763 then
764 if test -z "$with_dashes"
765 then
e4597aae
MO
766 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
767 fi
768 with_dashes=t
769 fi
770 PATH="$git_bin_dir:$PATH"
6cec5c68 771 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
772 if test -n "$with_dashes"
773 then
6cec5c68 774 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 775 fi
4e1be63c 776fi
6cec5c68 777GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 778GIT_CONFIG_NOSYSTEM=1
3c995beb 779GIT_ATTR_NOSYSTEM=1
8f323c00 780export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 781
5e87eae9
JH
782if test -z "$GIT_TEST_CMP"
783then
784 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
785 then
786 GIT_TEST_CMP="$DIFF -c"
787 else
788 GIT_TEST_CMP="$DIFF -u"
789 fi
790fi
791
6cec5c68 792GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 793export GITPERLLIB
6cec5c68 794test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
795 error "You haven't built things yet, have you?"
796}
e1970ce4 797
1c0cc756
RJ
798if ! test -x "$GIT_BUILD_DIR"/test-chmtime
799then
56cf9806
EW
800 echo >&2 'You need to build test-chmtime:'
801 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
802 exit 1
803fi
804
e1970ce4 805# Test repository
002d4ce8
JK
806TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
807test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
808case "$TRASH_DIRECTORY" in
809/*) ;; # absolute path is good
810 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 811esac
91c8b825 812test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 813rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 814 GIT_EXIT_OK=t
8d14ac94
JH
815 echo >&5 "FATAL: Cannot prepare test area"
816 exit 1
817}
818
90cff968
AR
819HOME="$TRASH_DIRECTORY"
820export HOME
821
1c0cc756
RJ
822if test -z "$TEST_NO_CREATE_REPO"
823then
38b074de 824 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 825else
38b074de 826 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 827fi
1bd9c648
LW
828# Use -P to resolve symlinks in our working directory so that the cwd
829# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 830cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 831
d5d9de1b
JS
832this_test=${0##*/}
833this_test=${this_test%%-*}
e6a6ddc9
TR
834if match_pattern_list "$this_test" $GIT_SKIP_TESTS
835then
836 say_color info >&3 "skipping test $this_test altogether"
837 skip_all="skip all tests in $this_test"
838 test_done
839fi
f17e9fbb 840
8648732e
BC
841# Provide an implementation of the 'yes' utility
842yes () {
843 if test $# = 0
844 then
845 y=y
846 else
847 y="$*"
848 fi
849
850 while echo "$y"
851 do
852 :
853 done
854}
855
f17e9fbb
JS
856# Fix some commands on Windows
857case $(uname -s) in
858*MINGW*)
859 # Windows has its own (incompatible) sort and find
860 sort () {
861 /usr/bin/sort "$@"
862 }
863 find () {
864 /usr/bin/find "$@"
865 }
5397ea31
JS
866 sum () {
867 md5sum "$@"
868 }
4114156a
JS
869 # git sees Windows-style pwd
870 pwd () {
871 builtin pwd -W
872 }
ee9fb68c 873 # no POSIX permissions
6fd1106a 874 # backslashes in pathspec are converted to '/'
fb9a2bea 875 # exec does not inherit the PID
a94114ad 876 test_set_prereq MINGW
cfa96496 877 test_set_prereq NOT_CYGWIN
a31d0665 878 test_set_prereq SED_STRIPS_CR
97669eed 879 test_set_prereq GREP_STRIPS_CR
4d715ac0 880 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
881 ;;
882*CYGWIN*)
883 test_set_prereq POSIXPERM
a31d0665
RJ
884 test_set_prereq EXECKEEPSPID
885 test_set_prereq NOT_MINGW
cfa96496 886 test_set_prereq CYGWIN
a31d0665 887 test_set_prereq SED_STRIPS_CR
97669eed 888 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
889 ;;
890*)
891 test_set_prereq POSIXPERM
6fd1106a 892 test_set_prereq BSLASHPSPEC
fb9a2bea 893 test_set_prereq EXECKEEPSPID
3ba9ba8f 894 test_set_prereq NOT_MINGW
cfa96496 895 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
896 ;;
897esac
704a3143 898
b082687c 899( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 900test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 901test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 902test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 903test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 904
bb946bba 905# Can we rely on git's output in the C locale?
30955229
JN
906if test -n "$GETTEXT_POISON"
907then
908 GIT_GETTEXT_POISON=YesPlease
909 export GIT_GETTEXT_POISON
5e9637c6 910 test_set_prereq GETTEXT_POISON
30955229
JN
911else
912 test_set_prereq C_LOCALE_OUTPUT
913fi
bb946bba 914
cabdee2c
JH
915# Use this instead of test_cmp to compare files that contain expected and
916# actual output from git commands that can be translated. When running
917# under GETTEXT_POISON this pretends that the command produced expected
918# results.
919test_i18ncmp () {
920 test -n "$GETTEXT_POISON" || test_cmp "$@"
921}
922
127df8c6
JH
923# Use this instead of "grep expected-string actual" to see if the
924# output from a git command that can be translated either contains an
925# expected string, or does not contain an unwanted one. When running
926# under GETTEXT_POISON this pretends that the command produced expected
927# results.
928test_i18ngrep () {
929 if test -n "$GETTEXT_POISON"
930 then
931 : # pretend success
932 elif test "x!" = "x$1"
933 then
934 shift
935 ! grep "$@"
936 else
937 grep "$@"
938 fi
939}
940
20073274
AS
941test_lazy_prereq PIPE '
942 # test whether the filesystem supports FIFOs
9443605b
ML
943 case $(uname -s) in
944 CYGWIN*)
945 false
946 ;;
947 *)
948 rm -f testfifo && mkfifo testfifo
949 ;;
950 esac
20073274
AS
951'
952
04083f27
JH
953test_lazy_prereq SYMLINKS '
954 # test whether the filesystem supports symbolic links
955 ln -s x y && test -h y
956'
c91cfd19 957
b018c735
JN
958test_lazy_prereq FILEMODE '
959 test "$(git config --bool core.filemode)" = true
960'
961
ac39aa61
MG
962test_lazy_prereq CASE_INSENSITIVE_FS '
963 echo good >CamelCase &&
964 echo bad >camelcase &&
965 test "$(cat CamelCase)" != good
966'
967
5b0b5dd4
MG
968test_lazy_prereq UTF8_NFD_TO_NFC '
969 # check whether FS converts nfd unicode to nfc
970 auml=$(printf "\303\244")
971 aumlcdiar=$(printf "\141\314\210")
972 >"$auml" &&
973 case "$(echo *)" in
974 "$aumlcdiar")
975 true ;;
976 *)
977 false ;;
978 esac
979'
980
09feffb6
JK
981test_lazy_prereq AUTOIDENT '
982 sane_unset GIT_AUTHOR_NAME &&
983 sane_unset GIT_AUTHOR_EMAIL &&
984 git var GIT_AUTHOR_IDENT
985'
986
6219bb22
JH
987test_lazy_prereq EXPENSIVE '
988 test -n "$GIT_TEST_LONG"
989'
990
e1ecd9e3
JH
991test_lazy_prereq USR_BIN_TIME '
992 test -x /usr/bin/time
993'
994
c91cfd19
ÆAB
995# When the tests are run as root, permission tests will report that
996# things are writable when they shouldn't be.
997test -w / || test_set_prereq SANITY
f838ce58
JK
998
999GIT_UNZIP=${GIT_UNZIP:-unzip}
1000test_lazy_prereq UNZIP '
1001 "$GIT_UNZIP" -v
1002 test $? -ne 127
1003'